;; pdfAID.lsp
;; 2024/11/05
;; f.izawa

;; 2024.01.23 
;; 2024/11/03 
;; 2024.04.24 PDFAID FׂĔɂǉ
;; 2024.04.25 PDFLINE _5 ɑΉ
;; 2024.05.04 CRCUT ł UNDO, G[΍ǉ
;;            oneLine ǉi2024/11/03 폜j
;;            txlines ǉi2024/11/03 폜j
;; 2024.09.05 PDFLINE Œ_3ȉ̃|C̕ǉARgAEg
;; 2024.09.06 IMPORTPDF R}h߁iPDFAID.EXE ŉ]pxɑΉ߁j
;; 2024/09/12 CRCUT  JbgΏۂ LINE ݂̂ɕύX
;;            LJT Ԃ؂̌ǉi2024/11/03 폜j
;;            CRTX ~A|Cɂ TEXT ̒SɈړǉ
;;            SPER XvC폜ǉ
;; 2024/10/29 txlines Ci2024/11/03 폜j
;; 2024/11/03 R}h𐮗
;;            CRTX ̑Ώە MTEXT ǉ
;; 2024/11/04 LNXDIET ɐ̊pxfǉ
;; 2024/11/05 LNEFIT ̃R}h LNFIT ̂܂܂̂C

;; pdfAID ̑̔r
;; BricsCAD V19 1 sec, BricsCAD V24 2 sec
;; IJCAD 2023 11 sec, GstarCAD 2024 2.2 sec
;; ZWCAD 2023 5.7 sec

;; R}h
;; ́AقڋLڏ
;; PDFAID  : HATCH  LWPOLYLINE ɕϊ
;;           ꕶi?,ŕ\j폜
;;           SOLIDAHATCH 폜
;;           }`̐F(7)ɕύX
;;           XvC͍폜Ȃ
;;          i蓮ŕꍇ́ASPLINEDIT R}hŃ|Cɕϊłj
;;           |C͕ꂸɎc
;;           ق PDF ̌ڂ̂܂܂ŕϊ
;;           dCH}̂悤ɍݓ}`̏ɓKĂ
;;           r͓d܂͎OdɂȂ
;; LNXDIET : HATCH̒ALWPOLYLINE  LINEɕϊ
;;           قڊpxdAOd{ɕϊ
;;           F̕ύX͂Ȃ̂ŁAʏŌȂƂ
;;           XvC͍폜Ȃ
;;          i蓮ŕꍇ́ASPLINEDIT R}hŃ|Cɕϊłj
;;           |C͍폜
;;           ͍폜̂ rۂ̏ɓKĂ
;;           rۂ̂Ƃ́APDFAID ł͂Ȃg
;;           LNXDIET  X  EXPLODE  X 
;; LNEFIT  : w苗ŔɂȂĂȂA͂ĂȂ[_C
;; TXLCAT  : s TEXT, MTEXT iMTEXT͕j
;; TXGCAT  : iXĝ悤ȕ\̕fiMTEXT͕j
;; SPER    : XvC폜
;; HTER    : nb`O폜

;; CRCUT   : CIRCLE, ELLIPSE, LWPOLYLINE Ɍ LINE Jbg
;;           JbgΏۂ̐ LINE ݂̂Ȃ̂ŁA|C͕Ă
;; CRTX    : ~A|Cɂ TEXT, MTEXT `͈͂̒_ɈړA`Ɏ܂ȂC
;;           MTEXT ͕
;;           dC}ʂ̒[qԍz
;; PDFLINE : SOLID  RECTANGLE (LWPOLYLINE) ɕϊꂽ\̌r LINE ɕϊ
;;           _3ȉ̃|C邾ŁA@\Iɂ LNXDIET Ƃقړ

(vl-load-com)

(defun ifs_pointW (pt off /) 
  (list 
    (list (- (car pt) off) (- (cadr pt) off) 0.0)
    (list (+ (car pt) off) (+ (cadr pt) off) 0.0)
  )
)

;; vle-string-replace 
(defun ifs_string_replace (newStr oldStr inStr / lastStr) 
  (while (/= lastStr inStr) 
    (setq lastStr inStr)
    (setq inStr (vl-string-subst newStr oldStr inStr))
  )
  inStr
)

;; WXĝA݋ő 2 _𓾂
(defun ifs_get_max_pos(plist / cnt i j posa posb dist temp)
	(setq
		cnt (length plist)
		i 0
		dist 0.0
	)
	(if (>= cnt 2)
		(repeat cnt
			(setq j (+ i 1))
			(repeat (- cnt i 1)
				(if (> (setq temp (distance (nth i plist)(nth j plist))) dist)
					(setq
						dist temp
						posa (nth i plist)
						posb (nth j plist)
					)
				)
				(setq j (1+ j))
			)
			(setq i (1+ i))
		)
	)
	(if (and posa posb)
		(list posa posb)
		nil
	)
)

;; ꒼ŏdĂ邩
(defun lineOnLine(p1 p2 p3 p4 fuz / ang p2A p3A p4A)
  (setq 
    ang (angle p1 p2) ;;fuz 1e-8
  	p2A (rotateBase p1 p2 (- ang))
  	p3A (rotateBase p1 p3 (- ang))
  	p4A (rotateBase p1 p4 (- ang))
	)
  (and 
		(equal (cadr p1) (cadr p2A) fuz)
		(equal (cadr p1) (cadr p3A) fuz)
		(equal (cadr p1) (cadr p4A) fuz)
    (or 
      (and (>= (car p1 )(car p3A))(<= (car p1)(car p4A)))
      (and (<= (car p1 )(car p3A))(>= (car p1)(car p4A)))
      (and (>= (car P2A)(car p3A))(<= (car p2A)(car p4A)))
      (and (<= (car p2A)(car p3A))(>= (car p2A)(car p4A)))
      (and (>= (car P3A)(car p1 ))(<= (car p3A)(car p2A)))
      (and (<= (car p3A)(car p1 ))(>= (car p3A)(car p2A)))
      (and (>= (car P4A)(car p1 ))(<= (car p4A)(car p2A)))
      (and (<= (car p4A)(car p1 ))(>= (car p4A)(car p2A)))
		)    
	)
)
;; _𒆐SɍW]
(defun rotateBase(base pt ang / x y)
  (setq 
    x (- (car  pt)(car  base))
    y (- (cadr pt)(cadr base))
	)
  (list 
    (+ (* x (cos ang))(- (* y (sin ang)))(car  base))
    (+ (* x (sin ang))(* y (cos ang))(cadr base))
    (caddr pt)
  )
)

;; IZbg`͈͂𓾂
;; ȂƂ nil Ԃ
;; ex: fil = "*LINE,CIRCLE,ARC"
(defun ifs_getSSRect (ss fil / i len maxPt maxVpt minPt minVpt result ret xLst yLst 
                      ename ent etype
                     ) 
  (setq len (sslength ss) i 0 result nil)
  (repeat len 
    (setq ename (ssname ss i)
          ent   (entget ename)
          etype (cdr (assoc 0 ent))
    )
    (if (wcmatch etype fil) 
      (progn 
        ;; AutoCAD ł́A(vlax-ename->vla-object ename) ŃG[ɂȂ
        (vla-getboundingbox (vlax-ename->vla-object ename) 'minVpt 'maxVpt)
        (setq minPt (vlax-safearray->list minVpt)
              maxPt (vlax-safearray->list maxVpt) ;;
              xLst  (append xLst (list (car minPt) (car maxPt)))
              yLst  (append yLst (list (cadr minPt) (cadr maxPt)))
        )
      )
    )
    (setq i (1+ i))
  )
  (if (and xlst ylst) 
    (setq minPt (list (apply 'min xLst) (apply 'min yLst) 0)
          maxPt (list (apply 'max xLst) (apply 'max yLst) 0)
          ret   (not (equal minPt maxPt 0.0001))
    )
  )
  (if ret 
    (setq result (list minpt maxpt))
  )
  result
)

;; solid 4_ 擾AWXgԂ
(defun func_solidxx (ename chkFlag / cnt code ent j lst pts ss1 plcnt code10lst) 
  (setq ent   (entget ename)
        plcnt 0
  )
  (if chkFlag 
    (progn 
      (setq code 10
            lst  nil
            j    0
            cnt  0
      )
      (repeat 4 
        (setq lst (append lst (list (cdr (assoc code ent)))))
        (setq code (1+ code))
      )
      (repeat 4 
        (setq pts (ifs_pointW (nth j lst) 0.05))
        (if (setq ss1 (ssget "C" (car pts) (cadr pts) '((0 . "LWPOLYLINE")))) 
          (if (> (sslength ss1) 0) 
            (setq cnt (1+ cnt))
          )
        )
        (setq j (1+ j))
      )
      (if (< cnt 4) 
        (progn 
          (if (not (equal (nth 2 lst) (nth 3 lst) 0.0001)) 
            (setq code10lst (list (nth 0 lst) (nth 1 lst) (nth 3 lst) (nth 2 lst)))
            (setq code10lst (list (nth 0 lst) (nth 1 lst) (nth 3 lst)))
          )
        )
      )
    )
  )
  (entdel ename)
  code10lst
)

;; gp 2024/09/06 AutoCAD ŃG[ɂȂ邽
;; ł HATCH ̗֊sۂ}`邩
(defun func_hatchxx (ename / code ent i len lst xmin xmax ymin ymax dist ssrect 
                     ssarea box boxarea fil xlst ylst mkflag ) 
  (setq mkflag T)
  (setq ent (entget ename)
        len (length ent)
        i   0
  )
  ;;_
  (repeat len 
    (setq code (car (nth i ent)))
    (if (or (= code 10) (= code 11)) 
      (setq lst (append lst (list (cdr (nth i ent)))))
    )
    (setq i (1+ i))
  )
  ;; _͂`̒ɐ}`邩
  (if (and lst (> (setq len (length lst)) 1)) 
    (progn 
      (setq xmin 0.0
            xmax 0.0
            ymin 0.0
            ymax 0.0
            dist 0.0
            i    1
      )
      (repeat (1- len) 
        (setq xlst (append xlst (list (car (nth i lst))))
              ylst (append ylst (list (cadr (nth i lst))))
        )
        (setq i (1+ i))
      )
      (if xlst 
        (setq xmin (apply 'min xlst)
              xmax (apply 'max xlst)
        )
      )
      (if ylst 
        (setq ymin (apply 'min ylst)
              ymax (apply 'max ylst)
        )
      )
      (setq dist (distance (list xmin ymin) (list xmax ymax)))
      (if (and (> (- xmax xmin) 0.1) (> (- ymax ymin) 0.1) (> dist 0.0)) 
        (progn 
          ;; ]T݂O̖ʐ
          (setq ssarea (* (- xmax xmin) (- ymax ymin)))
          (setq xmin (- xmin 0.2)
                xmax (+ xmax 0.2)
          )
          (setq ymin (- ymin 0.2)
                ymax (+ ymax 0.2)
          )
          (setq fil "*LINE,CIRCLE,ARC,ELLIPSE")
          ;; _͈̔͂̏Ő`̐}`擾
          (if 
            (setq ssrect (ssget "W" 
                                (list xmin ymin)
                                (list xmax ymax)
                                (list (cons 0 fil))
                         )
            )
            (progn 
              ;; ͈͓̔̐}`͂`擾
              (if (setq box (ifs_getSSRect ssrect fil));; AutoCAD ł̓G[ɂȂ 
                (progn 
                  (setq boxarea (* (- (car (cadr box)) (car (car box))) 
                                   (- (cadr (cadr box)) (cadr (car box)))
                                )
                  )
                  ;; ʐϔ 75% 菬́AHATCHGENERATEBOUNDARY s
                  (setq mkflag (< (/ boxarea ssarea) 0.85))
                )
              )
            )
          )
        )
      )
    )
  )
  mkflag
)

;; PDFIMPORT ō쐬ꂽ SOLIDAHATCH obT폜
;; ꕶ͍폜
(defun do_pdfAID (xflag / p1 p2 ename ent i len name ss str str1 lwpcnt bndcnt repcnt ticks 
                 lwplst lst j len2 mklst
                ) 
  (setq lwpcnt 0
        bndcnt 0
        repcnt 0
  )
  (if (not xflag)
    (if (setq p1 (getpoint "\nIR[i[1_ڂw : ")) 
      (if (setq p2 (getcorner p1 "\n2_ڂw : ")) 
        (setq ss (ssget "W" p1 p2 '((0 . "SOLID,HATCH,*TEXT"))))
      )
    )
    (setq ss (ssget "x" '((0 . "SOLID,HATCH,*TEXT"))))
  )
  (if ss 
    (progn 
      (setq ticks (getvar "DATE"))
      (setvar "CMDECHO" 0)
      (command "_UNDO" "BE")
      (setq len (sslength ss) i 0)
      (repeat len 
        (setq ename (ssname ss i) ent (entget ename))
        (setq name (cdr (assoc 0 ent)))
        (cond 
          ((= name "SOLID")
           ;; 쐬 LWP WXg SOLID ͍폜
           (setq lwplst (append lwplst (list (func_solidxx ename T))))
          )
          ;; SPLINE, LINE ɕϊ
          ((= name "HATCH")
            (progn
              (setq mklst (append mklst (list ename)))
            )
          )
          ;; ꕶ폜
          ((wcmatch name "*TEXT")
           (progn 
             (setq str (cdr (assoc 1 ent)))
             (setq str1 (ifs_string_replace "" (chr 65533) str)) ;; bRICScad
             (setq str1 (ifs_string_replace "" "\\U+FFFD" str1)) ;; IJCAD
             (if (/= str str1) 
               (progn 
                 (entmod (subst (cons 1 str1) (assoc 1 ent) ent))
                 (setq repcnt (1+ repcnt))
               )
             )
           )
         )
          ;; XvC͉Ȃ
          ; ((= name "SPLINE")
          ;   (progn
          ;     (command "_SPLINEDIT" ename "p" 10 "")
          ;   )
          ; )
        )
        (setq i (1+ i))
      )

      ;; HATCH ̗֊s쐬
      (if mklst 
        (progn 
          (setq len (length mklst) i   0)
          (repeat len 
            (setq bndcnt (1+ bndcnt))
            (command "_HATCHGENERATEBOUNDARY" (nth i mklst) "")
            (setq i (1+ i))
          )
        )
      )
      ;; ̌ HATCH 폜
      (setq len (sslength ss) i   0)
      (repeat len 
        (setq ename (ssname ss i)
              ent   (entget ename)
        )
        (setq name (cdr (assoc 0 ent)))
        (if (= name "HATCH") (entdel ename))
        (setq i (1+ i))
      )

      ;; SOLID  4 _ LWPOLYLINE 쐬
      (if lwplst 
        (progn 
          (setq len (length lwplst)
                i   0
          )
          ; (setq co (strcase (getvar "CECOLOR")))
          ; (cond
          ;   ((= co "BYLAYER")(setq code62 256))
          ;   ((= co "BYBLOCK")(setq code62 0))
          ;   (T (setq code62 (atoi co)))
          ; )
          (repeat len 
            (if (setq lst (nth i lwplst)) 
              (progn 

                (setq lwpcnt (1+ lwpcnt))
                (setq len2 (length lst)
                      j    0
                )
                (if (= len2 4) 
                  (command "_PLINE" 
                           "none"
                           (nth 0 lst)
                           "none"
                           (nth 1 lst)
                           "none"
                           (nth 2 lst)
                           "none"
                           (nth 3 lst)
                           "C"
                  )
                )
                (if (= len2 3) 
                  (command "_PLINE" 
                           "none"
                           (nth 0 lst)
                           "none"
                           (nth 1 lst)
                           "none"
                           (nth 2 lst)
                           "C"
                  )
                )
                ; (setq ent '((0 . "LWPOLYLINE")));; model(67=0)
                ; (setq ent (append ent (list
                ;                         (cons 67 0)
                ;                         (cons 8 (getvar "CLAYER"))
                ;                         (cons 6 (getvar "CELTYPE"))
                ;                         (cons 62 code62)
                ;                         (cons 90 len2)
                ;                         (cons 70 1)))
                ; )
                ; (repeat len2
                ;   (setq ent (append ent (list (cons 10 (list (car (nth j lst)) (cadr (nth j lst)))))))
                ;   (setq ent (append ent (list (cons 40 0.0)(cons 41 0.0)(cons 43 0.0))))
                ;   (setq j (1+ j))
                ; )
                ; (entmake ent)
              )
            )
            (setq i (1+ i))
          )
        )
      )
      (if (and p1 p2) 
        (if (setq ss (ssget "W" p1 p2)) 
          (command "_CHPROP" ss "" "c" 7 "") ;; 2024.04.24
        )
      )
      (command "_UNDO" "END")
      (setvar "CMDECHO" 1)
      (princ "\n")
      (princ (rtos (* (- (getvar "DATE") ticks) 60 60 24) 2 1))
      (princ " sec")
    )
  )
  (princ 
    (strcat "\n" 
            (itoa bndcnt)
            "  HATCH ̗֊s쐬A "
            (itoa lwpcnt)
            "  SOLID ̗֊s쐬A "
            (itoa repcnt)
            " ̓ꕶ폜܂B"
    )
  )
  (princ)
)

(defun c:PDFAID()
  (do_pdfaid nil)
  (princ)
)

(defun c:PDFAIDX() ;; ׂ
  (do_pdfaid T)
  (princ)
)

;; sSȁiɒ[_ȂĂȂjr LINE 𐮌`
(defun c:LNEFIT (/ dif ent i len p10 p11 ss xlst ylst) 
  (if (not (setq dif (getdist "\nꂽ[_̌o͈͂̍ől < 0.8 > : "))) 
    (setq dif 0.8)
  )
  (if (setq ss (ssget '((0 . "LINE")))) 
    (progn 
      (setq len  (sslength ss)
            i    0
            xlst nil
            ylst nil
      )
      (repeat len 
        (setq ent (entget (ssname ss i)))
        (setq p10 (cdr (assoc 10 ent))
              p11 (cdr (assoc 11 ent))
        )
         (if (equal (car p10) (car p11) 0.2) 
          (setq xlst (append xlst (list (/ (+ (car p10)(car p11)) 2.0))))
          (if (equal (cadr p10) (cadr p11) 0.2) 
            (setq ylst (append ylst (list (/ (+ (cadr p10)(cadr p11)) 2.0))))
          )
        )
        (setq i (1+ i))
      )
      (do_lnefit xlst ylst (* dif 2.0))
    )
  )
  (princ)
)
(defun do_lnefit (xlst ylst dif / ename ent fuz i j k len lst p10 p11 pts ss) 
  (if (and xlst ylst) 
    (progn 
      (setq fuz (* dif 0.5)) ;; rƂ덷
      (setq xlst (vl-sort xlst '<)
            ylst (vl-sort ylst '>)
      )
      (setq lst nil
            i   0
      )
      (repeat (length xlst) 
        (if (= i 0) 
          (setq lst (append lst (list (nth 0 xlst))))
          (if (> (- (nth i xlst) (last lst)) fuz) 
            (setq lst (append lst (list (nth i xlst))))
          )
        )
        (setq i (1+ i))
      )
      (setq xlst lst)
      (setq lst nil
            i   0
      )
      (repeat (length ylst) 
        (if (= i 0) 
          (setq lst (append lst (list (nth 0 ylst))))
          (if (> (- (last lst) (nth i ylst)) fuz) 
            (setq lst (append lst (list (nth i ylst))))
          )
        )
        (setq i (1+ i))
      )
      (setq ylst lst)
      (setq lst nil
            i   0
      )
      (repeat (length ylst) 
        (setq j 0)
        (repeat (length xlst) 
          (setq pts (ifs_pointw (list (nth j xlst) (nth i ylst)) fuz)) ;; ꂽ[_o͈̔
          (if (setq ss (ssget "C" (car pts) (cadr pts) '((0 . "LINE")))) 
            (progn 
              (setq len (sslength ss)
                    k   0
              )
              (repeat len 
                (setq ename (ssname ss k)
                      ent   (entget ename)
                )
                (setq p10 (cdr (assoc 10 ent))
                      p11 (cdr (assoc 11 ent))
                )
                (if (ifs_inArea p10 (car pts) (cadr pts)) 
                  (entmod 
                    (subst (cons 10 (list (nth j xlst) (nth i ylst) 0.0)) 
                           (assoc 10 ent)
                           ent
                    )
                  )
                )
                (if (ifs_inArea p11 (car pts) (cadr pts)) 
                  (entmod 
                    (subst (cons 11 (list (nth j xlst) (nth i ylst) 0.0)) 
                           (assoc 11 ent)
                           ent
                    )
                  )
                )
                (setq k (1+ k))
              )
            )
          )
          (setq j (1+ j))
        )
        (setq i (1+ i))
      )
    )
  )
)

;; LWPolyline, HATCH  PDFIMPORT ꂽrۂd LINEP{ɐ
;; ͍폜
(defun c:LNXDIET( / ss n i j xxlst temp
                  ename1 ent1 lay1 p1 p2 typ1 col1
                  ename2 ent2 lay2 p3 p4 typ2 col2
                  pts loop cnt fuz d1 d2 f ename fuzdeg)
  ;; 2024/11/03 قړ̔rɐ̌X̔fǉ
  (setq fuz 0.8);; mm
  (setq fuzdeg 0.5);; deg
  (if (setq f (getdist (strcat "\ne덷 < " (rtos fuz 2 3) " > : " )))
    (setq fuz f)
  )
  (if (setq ss (ssget '((0 . "*LINE,HATCH"))))
    (progn
      (setq xxlst (explodeLWP ss) i 0)
      ;(redraw)     
      (repeat (length xxlst)
        (setq ename (nth i xxlst))
        (if (= "LINE" (cdr (assoc 0 (entget ename))))
          (setq temp (append temp (list ename)))
        )
        (setq i (1+ i))
      )
      (setq xxlst temp temp nil)
      ; (setq xxlst (func_xxlstlnhv xxlst fuzdeg));;c𐅕A  
      ; (princ (length xxlst))
    )
  )
	(if T
		(if (> (setq n (length xxlst)) 1)
			(progn
				(setq i 0 cnt 0)
				(repeat (1- n)
					(setq 
            ename1 (nth i xxlst) 
            ent1 (entget ename1)
						lay1 (cdr (assoc 8 ent1))
            p1 (cdr (assoc 10 ent1))
            p2 (cdr (assoc 11 ent1))
            typ1 nil col1 nil
          )
          (if (assoc 6  ent1) (setq typ1 (cdr (assoc 6  ent1))))
          (if (assoc 62 ent1) (setq col1 (cdr (assoc 62 ent1))))
      
					(setq j (1+ i) loop T)
					(while (and (< j n) loop)
						(setq 
              ename2 (nth j xxlst) 
              ent2 (entget ename2)
							lay2 (cdr (assoc 8 ent2))
							p3 (cdr (assoc 10 ent2))
							p4 (cdr (assoc 11 ent2))
              typ2 nil col2 nil
						)
          	(if (assoc 6  ent2) (setq typ2 (cdr (assoc 6  ent2))))
          	(if (assoc 62 ent2)	(setq col2 (cdr (assoc 62 ent2))))
            (setq d1 (distance p1 p2) d2 (distance p3 p4))
            
            (if (<= d1 fuz);; 폜A̔r
              (progn
                (entdel ename1)
                (setq loop nil)
              )
            )
            ;; قړ̔ȑ
            ;;(if (and loop (= lay1 lay2)(= typ1 typ2)(= col1 col2) (> d1 fuz)(> d2 fuz))
						(if (and loop (> d1 fuz)(> d2 fuz))
							(if (and (lineOnLine p1 p2 p3 p4 fuz)(equal_lineangle p1 p2 p3 p4 fuzdeg))
								(progn
                  (setq pts nil)
                  (setq d1 (distance p1 p2) d2 (distance p3 p4))
                  (if (equal d1 d2 fuz) ;; 
                    ;;n_[I_قړ
                    (if (and (equal p1 p3 fuz)(equal p2 p4 fuz))
                      (setq pts (list (ifs_midPoint p1 p3)(ifs_midPoint p2 p4)))
                      (if (and (equal p1 p4 fuz)(equal p2 p3 fuz))
                        (setq pts (list (ifs_midPoint p1 p4)(ifs_midPoint p2 p3))) 
                        (setq pts (ifs_get_max_pos (list p1 p2 p3 p4)));; ̗̒p
                      )
                    )
                    ;; Ⴄ̗͒p
                    (setq pts (ifs_get_max_pos (list p1 p2 p3 p4)))
                  )
                  (if pts
                    (progn
                      (princ ".")
          				    (setq cnt (1+ cnt))
                      (setq	ent2 (subst (cons 10 (car  pts))(assoc 10 ent2) ent2))
                      (setq ent2 (subst (cons 11 (cadr pts))(assoc 11 ent2) ent2))
                      ;;(princ ent2)
                      (entmod ent2)
                      (entupd ename2)
                      ;; 폜A̔r
                      (entdel ename1)
                      ;;(setq dellst (append dellst (list ename1)))
                      (setq loop nil)
                    )
                  )
								)
							)
            ) 
						(setq j (1+ j))
          )
					(setq i (1+ i))
        )
				(princ (strcat "\n" (itoa n) " ̂ " (itoa cnt) " 𐮗܂D"))
			)
    )
  )
  (princ)
)

;; LWPOLYLINE A ARC ܂܂ALINE ͂̂܂
(defun explodeLWP( ss / txlst len i ename objname elast ent bndlst obj lst vlobj j)
  (setvar "cmdecho" 0)
  (if ss
    (progn
      (setq len (sslength ss) i 0)
      (repeat len 
        (setq ename (ssname ss i))
        (setq ent (entget ename))
        (setq objname (cdr (assoc 0 ent)))
        (cond 
          ((= "LWPOLYLINE" objname)
            (progn
              (setq vlobj (vlax-ename->vla-object ename))
              (setq lst (vlax-safearray->list (vlax-variant-value (vla-Explode vlobj))))
              (foreach obj lst 
                (if (= (vla-get-ObjectName obj) "AcDbLine") 
                  (setq txlst (append txlst (list (vlax-vla-object->ename obj))))
                )
              )
              (entdel ename)              
            )
          )
          ((= "LINE" objname)
            (setq txlst (append txlst (list ename)))
          )
          ((= "HATCH" objname)
            (progn
              (setq bndlst nil j 0)
              (setq elast (entlast))
              ;;(setvar "cmdecho" 0)
              (command "_HATCHGENERATEBOUNDARY" ename "");
              (while (and elast (entnext elast))
                (setq bndlst (append bndlst (list (entnext elast))))
                (setq elast (entnext elast))
              )
              (if bndlst
                (progn
                  (entdel ename);;HATCH 폜
                  (repeat (length bndlst)
                    (setq ename (nth j bndlst))
                    (setq ent (entget ename))
                    (if (= "LWPOLYLINE" (cdr (assoc 0 ent)))
                      (progn
                        (setq vlobj (vlax-ename->vla-object ename))
                        (setq lst (vlax-safearray->list (vlax-variant-value (vla-Explode vlobj))))
                        (foreach obj lst 
                          (if (= (vla-get-ObjectName obj) "AcDbLine") 
                            (setq txlst (append txlst (list (vlax-vla-object->ename obj))))
                          )
                        )
                        (entdel ename)                        
                      )
                    )
                    (setq j (1+ j))
                  )
                )
              )
            )
          )
        )
        (setq i (1+ i))
      )
    )
  )
  txlst
)

(defun ifs_midPoint (p1 p2 / x) 
  (mapcar '(lambda (x) (/ x 2.0)) (mapcar '+ p1 p2))
)
(defun ifs_inArea (pt minPt maxPt) 
  (and 
    (>= (car pt) (car minPt))
    (<= (car pt) (car maxPt))
    (>= (cadr pt) (cadr minPt))
    (<= (cadr pt) (cadr maxPt))
  )
)
;; SOLID  RECT(LWPOLYLINE) ɕϊꂽ\̎d؂ LINE ɕϊ
(defun c:PDFLINE (/ dif ss len i ename ent lst d1 d2 j len2 pts xlst ylst p1 p2 co 
                  code62)
  ;; 2024.04.25 _ 5 ɑΉ
  ;; 2024.09.05 _ 3 ȉ͕ǉ  2024/09/05 Ƃ
  (if (not (setq dif (getdist "\nג RECTANGLE rƂ݂Ȃő̕ < 0.8 > : "))) 
    (setq dif 0.8)
  )
  ;;(setvar "cmdecho" 0)
  (if (setq ss (ssget '((0 . "LWPOLYLINE")))) 
    (progn 
      (setq co (strcase (getvar "CECOLOR")))
      (cond 
        ((= co "BYLAYER") (setq code62 256))
        ((= co "BYBLOCK") (setq code62 0))
        (T (setq code62 (atoi co)))
      )
      (setq len (sslength ss)
            i   0
      )
      (repeat len 
        (setq ename (ssname ss i)
              ent   (entget ename)
        )
        (setq len2 (length ent)
              j    0
              lst  nil
        )
        (repeat len2 
          (if (= 10 (car (nth j ent))) 
            (setq lst (append lst (list (cdr (nth j ent)))))
          )
          (setq j (1+ j))
        )
        ;;2024.04.25 ǉ
        (if (= 5 (length lst)) 
          (if (equal (nth 0 lst) (nth 4 lst) 10e-4) 
            (setq lst (cdr lst))
          )
        )
        (if (and lst (= 4 (length lst))) 
          (progn 
            (setq pts nil)
            (setq d1 (distance (nth 0 lst) (nth 1 lst)))
            (setq d2 (distance (nth 1 lst) (nth 2 lst)))
            (if (<= d1 dif) 
              (setq pts (list (ifs_midpoint (nth 0 lst) (nth 1 lst)) 
                              (ifs_midpoint (nth 2 lst) (nth 3 lst))
                        )
              )
              (if (<= d2 dif) 
                (setq pts (list (ifs_midpoint (nth 1 lst) (nth 2 lst)) 
                                (ifs_midpoint (nth 3 lst) (nth 0 lst))
                          )
                )
              )
            )
            (if pts 
              (progn 
                (setq p1 (car pts) p2 (cadr pts))
                (if (equal (car p1) (car p2) 0.1) 
                  (setq xlst (append xlst (list (/ (+ (car p1)(car p2)) 2.0))))
                  (if (equal (cadr p1) (cadr p2) 0.1) 
                    (setq ylst (append ylst (list (/ (+ (cadr p1)(cadr p2)) 2.0))))
                  )
                )
                (setq ent '((0 . "LINE")))
                (setq ent (append ent 
                                  (list (cons 8 (getvar "CLAYER")) 
                                        (cons 6 (getvar "CELTYPE"))
                                        (cons 62 code62)
                                  )
                          )
                )
                (entmake (append ent (list (cons 10 p1) (cons 11 p2))))
                (entdel ename)
              )
            )
          )
          ;; 2024/09/05  ǉ
          ; (if (and lst (>= 3 (length lst)))
          ;   (progn
          ;     (command "_EXPLODE" ename)
          ;   ) 
          ; )
        )
        (setq i (1+ i))
      )
      (do_lnefit xlst ylst dif)
    )
  )
  ;;(setvar "cmdecho" 1)
  (princ)
)

;; ~A|Cɂ TEXT, MTEXT `͈͂̒_ɈړA`Ɏ܂ȂC
;; dC}ʂ̒[qԍz
(defun C:CRTX(/ ss len i ename obj minpt maxpt midpt ss1 ename1 ent w tw txbox j len1 maxVpt minVpt 
              elast txlst)
  (prompt "\n}` TEXT, MTEXT ̊_𒆒ɕύX CIRCLE,ELLIPSE,LWPOLYLINE,SPLINE I : ")
  (if (setq ss (ssget '((0 . "CIRCLE,ELLIPSE,LWPOLYLINE,SPLINE"))))  
    (progn 
      (setvar "cmdecho" 0)j len1 
      (command "_undo" "be")
      (setq len (sslength ss) i 0)
      (repeat len 
        (setq ename (ssname ss i) Obj (vlax-ename->vla-object ename))
        (if obj
          (progn 
            (vla-getboundingbox Obj 'minVpt 'maxVpt)
            (setq minPt (vlax-safearray->list minVpt))
            (setq maxPt (vlax-safearray->list maxVpt))
          )
        )
        (if (and obj (setq ss1 (ssget "C" minpt maxpt '((0 . "*TEXT")))))
          (progn 
            (setq midpt (ifs_midPoint minpt maxpt))
            (setq len1 (sslength ss1) j  0)
            (repeat len1 
              (setq ename1 (ssname ss1 j))
              (setq ent (entget ename1))
              (if (= "MTEXT" (cdr (assoc 0 ent)))
                (progn
                  (setq txlst nil)
                  (setq elast (entlast))
                  (vl-cmdf "explode" ename1)
                  (while (and elast (entnext elast))
                    (setq txlst (append txlst (list (entnext elast))))
                    (setq elast (entnext elast))
                  )
                  (setq ent (entget (nth 0 txlst)))
                )
              )
              (setq txbox  (textbox ent))
              (setq w (- (car (cadr txbox))(car (car txbox))))
              
              (setq ent (subst (cons 72 1)(assoc 72 ent) ent))
              (setq ent (subst (cons 73 2)(assoc 73 ent) ent))
              (if (assoc 11 ent)
                (setq ent (subst (cons 11 midpt)(assoc 11 ent) ent))
                (setq ent (append ent (list (cons 11 midpt))))
              )
              (if (> w (* (- (car maxpt)(car minpt)) 0.85))
                (progn
                  (setq tw (cdr (assoc 41 ent)))
                  (setq ent (subst (cons 41 (* tw 0.85))(assoc 41 ent) ent))
                )
              )            
              (entmod ent)
              (setq j (1+ j))
            )
          )
        )
        (setq i (1+ i))
      )
      (command "_undo" "end")
      (setvar "cmdecho" 1)
    )
  )
  (princ)
)
(defun ifs_3dplist (ary / k len lst) 
  (setq k   0
        len (fix (/ (length ary) 3))
  )
  (repeat len 
    (setq lst (cons 
                (list (nth (* k 3) ary) 
                      (nth (+ (* k 3) 1) ary)
                      (nth (+ (* k 3) 2) ary)
                )
                lst
              )
    )
    (setq k (1+ k))
  )
  lst
)

;; CIRCLE, ELLIPSE, LWPOLYLINE Ɍ LINE@Jbg
(defun c:CRCUT (/ ss len i ename obj minpt maxpt ss1 j lst ename1 obj1 sary ubnd len1 
                maxVpt minVpt vpts k len2 p1 p2
               ) 
  ;; 2024.01.22 ǉ
  ;; 2024/09/12 JbgΏۂLINE ݂̂ɕύX  
  (prompt "\n LINE Jbg CIRCLE,ELLIPSE,LWPOLYLINE,SPLINE 𕔕ƂɑI : ")
  (if (setq ss (ssget '((0 . "CIRCLE,ELLIPSE,LWPOLYLINE,SPLINE")))) 
    (progn 
      (setvar "cmdecho" 0)
      (command "_undo" "be")
      (setq len (sslength ss)
            i   0
      )
      (repeat len 
        (setq ename (ssname ss i)
              Obj   (vlax-ename->vla-object ename)
        )
        (if obj  ;; 2024.05.04
          (progn 
            (vla-getboundingbox Obj 'minVpt 'maxVpt)
            (setq minPt (vlax-safearray->list minVpt))
            (setq maxPt (vlax-safearray->list maxVpt))
          )
        )
        ;;(command "_rectang" "non" minpt "non" maxpt)
        ;; 2024/09/12 JbgΏۂLINE ݂̂ɕύX
        (if (and obj (setq ss1 (ssget "C" minpt maxpt '((0 . "LINE")))))
          (progn 
            (setq len1 (sslength ss1)
                  j    0
            )
            ;;(princ "\n*LINE=")(princ len1)
            (repeat len1 
              (setq ename1 (ssname ss1 j))
              (if (not (equal ename ename1)) 
                (progn 
                  (setq obj1 (vlax-ename->vla-object ename1))
                  ;; LINE, POLYLINE ̉_
                  (setq vpts (vla-intersectwith obj obj1 acExtendOtherEntity))
                  ;;(setq vpts (vla-intersectwith obj obj1 acExtendThisEntity))
                  (setq sary (vlax-variant-value vpts)
                        ubnd (vlax-safearray-get-u-bound sary 1)
                  )
                  ;; (princ "\nubnd=")(princ ubnd)
                  (if (>= ubnd 2) 
                    (if (setq lst (ifs_3dplist (vlax-safearray->list sary))) 
                      (progn 
                        (setq len2 (length lst)
                              p1   nil
                              p2   nil
                        )
                        (if (= len2 2) 
                          (setq p1 (car lst)
                                p2 (cadr lst)
                          )
                          (if (> len2 2) 
                            (progn 
                              (setq p1 (car lst)
                                    k  1
                              )
                              (while (and (not p2) (< k len2)) 
                                (if (not (equal p1 (nth k lst) 0.001)) 
                                  (setq p2 (nth k lst))
                                )
                                (setq k (1+ k))
                              )
                            )
                          )
                        )
                        (if (and p1 p2) 
                          (progn 
                            ;;(command "_circle" p1 0.01)(command "_circle" p2 0.01)
                            (command "_break" ename1 "none" p1 "none" p2)
                          )
                        )
                      )
                    )
                  )
                  (setq j (1+ j))
                )
              )
            )
          )
        )
        (setq i (1+ i))
      )
      (command "_undo" "end")
      (redraw)
      (setvar "cmdecho" 1)
    )
  )
  (princ)
)


;; XvC폜
(defun c:SPER( / loop ss)
  (setq loop T)
  (while loop
    (prompt "\n폜XvCI < I > : ")
    (if (setq ss (ssget '((0 . "SPLINE"))))
      (progn
        (command "_ERASE" SS "")
      )
      (setq loop nil)
    )
   
  )
  (princ)
)

; nb`O폜
(defun c:HTER( / loop ss)
  (setq loop T)
  (while loop
    (prompt "\n폜nb`OI < I > : ")
    (if (setq ss (ssget '((0 . "HATCH"))))
      (progn
        (command "_ERASE" SS "")
      )
      (setq loop nil)
    )
  )
  (princ)
)

;; pxϊiWA -> xj
(defun ifs_degToRad (deg / rad) 
  (setq rad (* pi (/ deg 180.0)))
  (if (>= rad (* PI 2.0)) (setq rad (- rad (* PI 2.0))))
  (if (< rad 0.0) (setq rad (+ rad (* PI 2.0))))
  rad
)
;; pxϊix -> WAj
(defun ifs_radToDeg (rad / deg) 
  (setq deg (* 180.0 (/ rad pi)))
  (if (>= deg 360.0) (setq deg (- deg 360.0)))
  (if (< deg 0.0) (setq deg (1+ deg 360.0)))
  deg
)
;; 2̌Xi͖Ȃj
(defun equal_lineangle(p1 p2 p3 p4 fuzzdeg / ang1 ang2)
  (setq ang1 (angle p1 p2) ang2 (angle p3 p4))
  (angequal ang1 ang2 (ifs_degtorad fuzzdeg)) 
)
;; XΊpxixji͖Ȃj
(defun degequal( deg1 deg2 fuzzdeg / )
  (angequal (ifs_degToRad deg1) (ifs_degToRad deg2) (ifs_degToRad fuzzdeg))
)
;; XΊpxiWAji͖Ȃj
(defun angequal( ang1 ang2 fuzz / PI20 diff )
  (setq PI20 (* PI 2.0))
  (setq diff (abs (-  (+ ang1 PI20)  (+ ang2 PI20))))
  (or (equal diff 0.0 fuzz)(equal diff PI fuzz)(equal diff PI20 fuzz)(equal diff (* PI 3.0) fuzz))
)



(princ "\nPDFAID.lsp 2024.11.05")
(princ) 
